Formatted question description: https://leetcode.ca/all/877.html
877. Stone Game (Medium)
Alex and Lee play a game with piles of stones. There are an even number of piles arranged in a row, and each pile has a positive integer number of stones piles[i]
.
The objective of the game is to end with the most stones. The total number of stones is odd, so there are no ties.
Alex and Lee take turns, with Alex starting first. Each turn, a player takes the entire pile of stones from either the beginning or the end of the row. This continues until there are no more piles left, at which point the person with the most stones wins.
Assuming Alex and Lee play optimally, return True
if and only if Alex wins the game.
Example 1:
Input: [5,3,4,5] Output: true Explanation: Alex starts first, and can only take the first 5 or the last 5. Say he takes the first 5, so that the row becomes [3, 4, 5]. If Lee takes 3, then the board is [4, 5], and Alex takes 5 to win with 10 points. If Lee takes the last 5, then the board is [3, 4], and Alex takes 4 to win with 9 points. This demonstrated that taking the first 5 was a winning move for Alex, so we return true.
Note:
2 <= piles.length <= 500
piles.length
is even.1 <= piles[i] <= 500
sum(piles)
is odd.
Companies:
Google
Related Topics:
Math, Dynamic Programming
Solution 1. Bottomup DP
Let dp[i][j]
be the maximum difference of stone values, that is, the stones the first player can get minus the stones the second player can get.
dp[i][i] = A[i]
dp[i][j] = max(A[i]  dp[i + 1][j], A[j]  dp[i][j  1])
// OJ: https://leetcode.com/problems/stonegame/
// Time: O(N^2)
// Space: O(N^2)
class Solution {
public:
bool stoneGame(vector<int>& A) {
int dp[500][500] = {}, N = A.size();
for (int i = 0; i < N; ++i) dp[i][i] = A[i];
for (int i = N  2; i >= 0; i) {
for (int j = i + 1; j < N; ++j) dp[i][j] = max(A[i]  dp[i + 1][j], A[j]  dp[i][j  1]);
}
return dp[0][N  1] > 0;
}
};
Solution 2. Topdown DP
// OJ: https://leetcode.com/problems/stonegame/
// Time: O(N^2)
// Space: O(N^2)
class Solution {
int dp[500][500] = {};
int dfs(vector<int> &A, int i, int j) {
if (i == j) return A[i];
if (dp[i][j]) return dp[i][j];
return dp[i][j] = max(A[i]  dfs(A, i + 1, j), A[j]  dfs(A, i, j  1));
}
public:
bool stoneGame(vector<int>& A) {
return dfs(A, 0, A.size()  1) > 0;
}
};
Solution 3.
Notice that the length of piles
is even. So Alex can always pick piles with either even indices (piles[0], piles[2], ..., piles[n2]
) or odd indices (piles[1], piles[3], ..., piles[n1]
). Since the total number of stones is odd, so Alex can simply pick the group with more stones.
// OJ: https://leetcode.com/problems/stonegame/
// Time: O(1)
// Space: O(1)
class Solution {
public:
bool stoneGame(vector<int>& piles) {
return true;
}
};
Java

class Solution { public boolean stoneGame(int[] piles) { if (piles == null  piles.length == 0) return false; int length = piles.length; int[][] dp = new int[length][length]; for (int i = 0; i < length; i++) dp[i][i] = piles[i]; for (int i = length  2; i >= 0; i) { for (int j = i + 1; j < length; j++) dp[i][j] = Math.max(piles[i]  dp[i + 1][j], piles[j]  dp[i][j  1]); } return dp[0][length  1] > 0; } }

// OJ: https://leetcode.com/problems/stonegame/ // Time: O(N^2) // Space: O(N^2) class Solution { public: bool stoneGame(vector<int>& A) { int dp[500][500] = {}, N = A.size(); for (int i = 0; i < N; ++i) dp[i][i] = A[i]; for (int i = N  2; i >= 0; i) { for (int j = i + 1; j < N; ++j) dp[i][j] = max(A[i]  dp[i + 1][j], A[j]  dp[i][j  1]); } return dp[0][N  1] > 0; } };

class Solution: def stoneGame(self, piles): return True